<?php

$plugin_info = array(
						'pi_name'			=> 'BN Check File Exists ',
						'pi_version'		=> '1.0.0',
						'pi_author'			=> 'Chris Newton',
						'pi_author_url'		=> 'http://barrettnewton.com/docs',
						'pi_description'	=> 'Checks to see if a file exists on the server',
						'pi_usage'			=> bn_file_exists::usage()
					);
					
class Bn_file_exists{
	
		public function check_file()
		{
			if ($this->return_file())
			{
				return 1; 
			}
			else return null;  
		}
		public function return_file()
		{
			clearstatcache();
			
			global $TMPL, $FNS, $PREFS; 
			
			$tagdata 	= ""; 
			$src 		= ( ! $TMPL->fetch_param('src')) ? $TMPL->tagdata : $TMPL->fetch_param('src');
			$root_path 	= ( ! $TMPL->fetch_param('root_path')) ? '' : $TMPL->fetch_param('root_path');
			$debug 		= ( ! $TMPL->fetch_param('debug')) ? '' : $TMPL->fetch_param('debug');
			$wrap_left 	= ( ! $TMPL->fetch_param('wrap_left')) ? '' : $TMPL->fetch_param('wrap_left');
			$wrap_right	= ( ! $TMPL->fetch_param('wrap_right')) ? '' : $TMPL->fetch_param('wrap_right');
			
			
			$src = html_entity_decode($src);
			$src = str_replace('{site_url}', $FNS->fetch_site_index(1), $src);
			$src = str_replace("\r\n", "", $src);
			$src = str_replace("\r", "", $src);
			$src = str_replace("\n", '', $src);
			
			if(!$src || $src=='')
			{
					return $TMPL->no_results();
			}
			if (stristr($src, '<img'))
			{
				if($debug)
				{
					return "HTML is not an acceptable parameter for the Bn_file_exists plugin";
				}
				else
				{
					return $TMPL->no_results();
				}
			}
			if (stristr($src, 'http'))
			{
				$full_url 		= $src; 
				$parsed_url 	= parse_url($src);
				$src 			= $parsed_url['path'];
			}
			$img 				= pathinfo($src);
			
			$img_dirname		= ( ! isset($img['dirname'])) 	? '' : $img['dirname'];
			$img_basename 		= ( ! isset($img['basename'])) 	? '' : $img['basename'];
			$img_extension 		= ( ! isset($img['extension'])) ? '' : $img['extension'];
			$img_filename 		= str_replace('.'.$img_extension, '', $img_basename);
			$img_filename 		= $FNS->filename_security($img_filename);

			if ($root_path == "")
			{
				$root_path = isset($_SERVER['DOCUMENT_ROOT']) ? $_SERVER['DOCUMENT_ROOT'] : @getenv('DOCUMENT_ROOT');
			}
			$img_full_path = 	$FNS->remove_double_slashes(realpath($root_path ."/".$img_dirname)); 
			$img_location 	= 	$img_full_path ."/". $img_filename . "." .$img_extension; 
			$img_location 	= 	$FNS->remove_double_slashes($img_location);
			
			if (!is_file($img_location))
			{
				return false;
			}
			else
			{
				return $wrap_left .$src .$wrap_right; 
			}
			
		}
		public function usage()
		{
ob_start(); 
?>	

Checks to see if a file exists at the location passed in. If the file does not exist nothing is output by this plugin. If a file does exist at the location being passed in, the source location is returned. 

Parameters: 

src: the source of the file (http://whatever.com/whatever.jpg) If this parameter is not found, this plugin will parse the content between the plugin tags (see example 2. below)

root_path: (optional) the server's  path to the root of the file (useful if your file is not available at a publicly accessible location; http://something )

wrap_left: (optional) HTML or text that will appear before the file name (if it exists)

wrap_right: (optional) HTML or text that will appear after the file name (if it exists)
Example 1: 
	{exp:bn_file_exists:return_file src="http://whatevs.ext" wrap_left="<li>" wrap_right="</li>"}
Example 2:
	{exp:bn_file_exists:return_file wrap_left="<li>" wrap_right="</li>"}{site_url}whatevs.ext{/exp:bn_file_exists:return_file}
	
<?php
$buffer = ob_get_contents();

ob_end_clean(); 

	return $buffer;
	}
}
